/************************************************************************
     File:        CubeIt.cpp

     Author:     
                  Michael Gleicher, gleicher@cs.wisc.edu
     Modifier
                  Yu-Chi Lai, yu-chi@cs.wisc.edu
     
     Comment:     
		 
	 					    This program makes a simple 3D world with some cubes in it.
								It provides a user interface so that the user can select cubes
								and move them around. It also provides a basic user interface
								for the camera.
								
								This program is designed to serve as a starting platform for
								CS559 projects, or as reference for how to do different things.
								Remember: if you borrow code, you must give proper attribution!
								However, you are encouraged to borrow code from this
						
			Note:   i've built this to make it easy for me to make several
							different demos, so the code organization is kindof wierd
							i've had to put lots of common stuff here that you'd normally
							put into your window/widget class

              Written at October 2005
   
     Platform:    Visio Studio.Net 2003
*************************************************************************/
#pragma once


// we'll use the STL
#include <vector>

// in case this isn't defined
class Fl_Widget;

//*********************************************************************************
//
// Data structure to store the cubes
// You may want to remember more about the cubes (for example, if you
// want to have each be a different color, or ...)
//
//*********************************************************************************
class Cube {
	public:
		inline Cube(float _x, float _y, float _z, float _s=1) 
				:	x(_x), y(_y), z(_z), s(_s) {};
		float x,y,z;				// position of center
		float s;						// size of a side
};

//*********************************************************************************
// Keep a collection of cubes
// You might want to store more stuff yourself, so you'll need
// better data structures
//*********************************************************************************
extern std::vector<Cube> theCubes;

//*********************************************************************************
// Which of these cubes is "selected" 
// (-1 means none is selected, otherwise an index into "theCubes"
//*********************************************************************************
extern int selectedCube;

//*********************************************************************************
// Draw the list of cubes
// Note: since we might be drawing the shadow pass, we might not
//       want to draw colors. also we may, or may not, want to load
//       names for picking. WARNING: the names are offset by one from
//       the array indecies
// design issue: I am assuming there is a single global list of
//       cubes - you might want to use a more extensible design
//*********************************************************************************
void drawCubes(int doColors=1, int doNames=0);


//*********************************************************************************
// a cheesy UI
//
// Use FlTk Rollers to move the selected cube
//
// I don't recommend this interface - its just here to show you that
// there are simple things that work
//
// Make rollers - be sure you're inside of an FlTk Window
//                give it an xy position and size for the rollers
//                also give it an fltk widget to damage (your window)
//                anytime something changes
//*********************************************************************************
void makeRollers(int x, int y, int h, Fl_Widget* w);
